// Copyright (C) 2002 Samy Bengio (bengio@idiap.ch)
//                
//
// This file is part of Torch. Release II.
// [The Ultimate Machine Learning Library]
//
// Torch is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Torch is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Torch; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef PHONEME_SEQ_DATASET_INC
#define PHONEME_SEQ_DATASET_INC

#include "SeqDataSet.h"
#include "Dictionary.h"
#include "HMM.h"

namespace Torch {

/** This class is designed to create a dataset based on another
    dataset using parts only related to a given phoneme
   
    @author Samy Bengio (bengio@idiap.ch)
 */
class PhonemeSeqDataSet : public SeqDataSet
{
  public :

    /// create a new Phoneme dataset from generic SeqDataSet
    /// if alignment is not existant, then use models and do a linear alignment
    PhonemeSeqDataSet(SeqDataSet* data,int phoneme, Dictionary* dict, HMM** models=NULL);
    
    virtual void addExample(SeqExample* ex, int start, int end);

    virtual void freeMemory();

    virtual ~PhonemeSeqDataSet();
};


}

#endif     
